/**************************************************************
**
**         C SWING  v 3.1   31-JUL-1989 09:08:25.51
**         =========================================
**
**         Author    :  S.J.Brown
**
**         Copyright :  Public Domain
**
**         File      :  SWING_2.C
**
**         Language  :  VAXC
**
**         Compiler  :  VAX/VMS C v 2.4
**
**         VMS Ver.  :  5.1
**
***************************************************************
**
**         Change History
**         ==============
**
**         Date        Change                          Initials
**         ----------------------------------------------------
**         31-JUL-1989 Initial Version v3.0               SJB
**
**************************************************************/
 
/*
**  swing_2
*/
#include <stdio.h>
#include <ctype.h>
#include <smgdef.h>
#include <ssdef.h>
#include <lnmdef.h>
#include <psldef.h>
#include "more_descrip.h"
#include "swing.h"
#include "swing_refs.h"

#define TAB_SIZE		10
#define DN_DOWNWARDS		1
#define DN_UPWARDS		2

static int where_on = TRUE;
static int direction = DN_DOWNWARDS;

globalref int captive;

next_command(option,move_or_copy)
int option;
int move_or_copy;
{
    /*
    **  if option is true we allow all the options in the switch statement
    **  below - i.e. the situation where the user is driving around
    **  the dirs with nothing special going on
    **  
    **  if option is false user is selecting a dirctory, e.g. move, copy
    */
    short key;
    int i,sub_dir_ptr[MAX_LEVEL],levels,length,orig_current_line;
    int *mark;
    char dir[SPEC_SIZE+1];
    char name[SPEC_SIZE+1];
    char where[SPEC_SIZE+1];
    char filename[SPEC_SIZE+1];
    char new_filename[SPEC_SIZE+1];
    char marked_dir[SPEC_SIZE+1];

    /*
    **  for set_init_position let it know that we've started to use
    **  the display
    */
    started = TRUE;
    set_init_position();
    refresh_display();
    first_node_in_stack(curr_l_ptr->n_ptr[current_level]);

    while(1)
    {
        set_default(curr_l_ptr->n_ptr[current_level]->dir_name);

        /*
        **  show either current def dir or root dir
        */  
        if (where_on)
        {
            show_def(junk);
            sub_title_underline(junk);
        }
        else
        {
            strcpy(where,curr_l_ptr->dp->dir_name);
            
            /*
            **  and centre it
            */
            for (i = 0; i < 40; i++)
                junk[i] = ' ';
    
            sprintf(&junk[40 - (strlen(where))/2],"%s",where);
    
            /*
            **  and display it
            */
            sub_title_underline(junk);
        }

	/*
	**  move_or_copy with true option is filmgr_start
	*/
	if (option && move_or_copy)
	{
	    move_or_copy = FALSE;
	    goto call_swing_files;
	}

        /*
        **  get user to do something
        */
        key = get_key(ALLOW_AUTO | ALLOW_CLOCK);

        if (key == SMG$K_TRM_QUESTION_MARK)
            key = main_menu_options();

        if (!key)
            continue;

        switch(key) 
        {
case SMG$K_TRM_EXCLAMATION_POINT:
            if (!option)
            {
                ding(displayb);
                break;
            }
	    dir_stats(curr_l_ptr->n_ptr[current_level]);
	    break;

case SMG$K_TRM_PERCENT_SIGN:
            if (!option)
            {
                ding(displayb);
                break;
            }
	    defragment_dirs(curr_l_ptr->n_ptr[current_level]);
	    break;

case SMG$K_TRM_CTRLD:
            if (!option)
            {
                ding(displayb);
                break;
            }
	    if (captive)
	    {
		message(CAPTIVE_ERRMSG);
		break;
	    }
            user_options(FALSE,
                         "",
                         curr_l_ptr->n_ptr[current_level],
                         SHOW_FILES);
            title(MTITLE);
            break;

case SMG$K_TRM_FIND:
	    find_prev_node(curr_l_ptr->n_ptr[current_level]);
	    break;
	    
case SMG$K_TRM_SELECT:
	    find_next_node(curr_l_ptr->n_ptr[current_level]);
            break;

case SMG$K_TRM_SLASH:
            /*
            **  leave my mark
            */
            strcpy(sl_mark_dir,curr_l_ptr->n_ptr[current_level]->dir_name);
            sl_mark_set = TRUE;
            refresh_display();
            message("mark set");
            break;

case SMG$K_TRM_LEFT_BRACE:
            /*
            **  leave my mark
            */
            strcpy(cb_mark_dir,curr_l_ptr->n_ptr[current_level]->dir_name);
            cb_mark_set = TRUE;
            refresh_display();
            message("mark set");
            break;

case SMG$K_TRM_LEFT_PAREN:
            /*
            **  leave my mark
            */
            strcpy(rb_mark_dir,curr_l_ptr->n_ptr[current_level]->dir_name);
            rb_mark_set = TRUE;
            refresh_display();
            message("mark set");
            break;

case SMG$K_TRM_LEFT_BRACKET:
            /*
            **  leave my mark
            */
            strcpy(br_mark_dir,curr_l_ptr->n_ptr[current_level]->dir_name);
            br_mark_set = TRUE;
            refresh_display();
            message("mark set");
            break;

case SMG$K_TRM_BACKSLASH:
	    mark = &sl_mark_set;
	    if (*mark)
		strcpy(marked_dir,sl_mark_dir);
	    goto hunt_the_mark;
            break;

case SMG$K_TRM_RIGHT_BRACE:
	    mark = &cb_mark_set;
	    if (*mark)
		strcpy(marked_dir,cb_mark_dir);
	    goto hunt_the_mark;
            break;

case SMG$K_TRM_RIGHT_PAREN:
	    mark = &rb_mark_set;
	    if (*mark)
		strcpy(marked_dir,rb_mark_dir);
	    goto hunt_the_mark;
            break;

case SMG$K_TRM_RIGHT_BRACKET:
	    mark = &br_mark_set;
	    if (*mark)
		strcpy(marked_dir,br_mark_dir);
	
	hunt_the_mark:;
            /*
            **  return to mark
            */
            if (!*mark)
            {
                message("mark not set");
            }
            else
            {
                /*
                **  static to avoid code optimisation
                */
                static LINE *clp;
                int li,le;

                render(current_line,current_level,NORMAL_RENDITION);
                clp = first_line_ptr;
                for (li = 0; li < total_lines; li++)
                {
                    for (le = 0; le < MAX_LEVEL; le++)
                    {
                        if (clp->n_ptr[le])
                        {
                            if (strcmp(marked_dir,clp->n_ptr[le]->dir_name) == 0)
                            {
                                curr_l_ptr = clp;
                                current_line = li;
                                current_level = le;
                                redo_display(TRUE);
                                goto found_mark;
                            }    
                        }
                    }
                    clp = clp->forw_ptr;
                }
                warning("Mark not found");
                *mark = FALSE;
            }
        found_mark:;
            render(current_line,current_level,SPECIAL_RENDITION);
            break;

case SMG$K_TRM_LOWERCASE_V:
case SMG$K_TRM_UPPERCASE_V:
            if (!option)
            {
                ding(displayb);
                break;
            }
            show_version();
            break;

case SMG$K_TRM_AMPERSAND:
	    if (!option)
		ding(displayb);
	    else
		show_quotas(curr_l_ptr->n_ptr[current_level]);

	    break;

case SMG$K_TRM_REMOVE:
case SMG$K_TRM_LOWERCASE_K:
case SMG$K_TRM_UPPERCASE_K:
            if (!option)
            {
                ding(displayb);
                break;
            }
            if (fdp->forw_ptr)
            {
                /*
                **  we've more than one structure, so we can zap
                **  this one
                */
                show_deleting(curr_l_ptr->dp->fnp,DELETING_RENDITION,FALSE);
                if (confirm_user("Remove this structure from the display Y/N [N] ?","Y"))
                    extract_structure(curr_l_ptr->dp);
                else
                {
                    show_deleting(curr_l_ptr->dp->fnp,NORMAL_RENDITION,FALSE);
                    render(current_line,current_level,SPECIAL_RENDITION);
                }
            }
            else
                warning("You can't remove the only structure being displayed");
            break;

case SMG$K_TRM_INSERT_HERE:
case SMG$K_TRM_LOWERCASE_I:
case SMG$K_TRM_UPPERCASE_I:
            if (!option)
            {
                ding(displayb);
                break;
            }
	    if (captive)
	    {
		message(CAPTIVE_ERRMSG);
		break;
	    }
            {
                int my_line, my_level, my_top_line;
                LINE *my_curr_l_ptr;

                new_filename[0] = 0;
                if (get_user_input("Input structure to insert [NONE] ",
                                   new_filename,
                                   NAME_SIZE))
                {
                    if (!add_a_dstructure(new_filename))
                    {
                        sprintf(junk,
                                "Directory %c%s%c not found",
                                '"',
                                new_filename,
                                '"');
                        warning(junk);
                    }
                }
            }
            break;

case SMG$K_TRM_LESS_THAN:
            if (!option)
            {
                ding(displayb);
                break;
            }
	    if (captive)
	    {
		message(CAPTIVE_ERRMSG);
		break;
	    }
            remote_files(curr_l_ptr->n_ptr[current_level]->dir_name,0,IMPORT);
            break;

case SMG$K_TRM_UPPERCASE_W:
case SMG$K_TRM_LOWERCASE_W:
            if (where_on)
                where_on = FALSE;
            else
                where_on = TRUE;
            break;

case SMG$K_TRM_UPPERCASE_O:
case SMG$K_TRM_LOWERCASE_O:
            show_broadcasts();
            break;

case SMG$K_TRM_UPPERCASE_U:
case SMG$K_TRM_LOWERCASE_U:
            if (!option)
            {
                ding(displayb);
                break;
            }
            purge_dirs();
            break;

case SMG$K_TRM_CTRLG:
            if (!option)
            {
                ding(displayb);
                break;
            }
            if (confirm_user("Two options, N for a narrow listing, W for a wide listing [Narrow] ?","W"))
                create_listing(TRUE, FALSE);
            else
                create_listing(FALSE, FALSE);
            break;

case SMG$K_TRM_DOLLAR_SIGN:
            if (!option)
            {
                ding(displayb);
                break;
            }
	    if (captive)
	    {
		message(CAPTIVE_ERRMSG);
		break;
	    }
            execute_dcl("");
            break;
            
case SMG$K_TRM_UPPERCASE_C:
case SMG$K_TRM_LOWERCASE_C:
	    /*
	    **  Must be carefull here - we could be calling this when we
	    **  have a message on the bottom line , i.e. move to new
	    **  parent, when we're creating a new directory. If so we must
	    **  clear the bottom line. We must set message_set = 1 so that
	    **  the bottom line gets cleared
            */
            if (!option)
            {
	        message_set = 1; 
		message(" ");
	    }
            add_dirs();
            if (!option)
            {
		/*
		**  if we were letting the user cruise around to
		**  select a new dir for MOVE or COPY we'll
		**  throw out the desired prompt
                */
                if (move_or_copy == MOVE_FILES)
                    travel_to_dir();
		else
		    travel_to_dir_remote();
            }
            break;

case SMG$K_TRM_UPPERCASE_D:
case SMG$K_TRM_LOWERCASE_D:
            if (!option)
            {
                ding(displayb);
                break;
            }
            delete_dirs(FALSE);
            break;

case SMG$K_TRM_AT_SIGN:
            if (!option)
            {
                ding(displayb);
                break;
            }
	    protect_dirs(TRUE);
	    break;

case SMG$K_TRM_TILDE:
            if (!option)
            {
                ding(displayb);
                break;
            }
	    protect_dirs(FALSE);
	    break;

case SMG$K_TRM_UPPERCASE_L:
case SMG$K_TRM_LOWERCASE_L:
            if (!option)
            {
                ding(displayb);
                break;
            }
            locate_file(filename);
            break;
            
case SMG$K_TRM_CTRLE:
            if (!option)
            {
                ding(displayb);
                break;
            }

            new_filename[0] = 0;
            if (get_user_input("Input filename to edit ? [NONE]",
                               new_filename,
                               NAME_SIZE))
            {
                if (parse_file(new_filename))
                {
                    edit_file(curr_l_ptr->n_ptr[current_level]->dir_name,
                              new_filename);
                    swing_files(curr_l_ptr->n_ptr[current_level],
                                new_filename,
                                SHOW_FILES);
		    if (total_files == 0)
			strcpy(curr_l_ptr->n_ptr[current_level]->dir_spec,
			       DEFAULT_DIR_SPEC);
                }
            }
            break;

case SMG$K_TRM_ZERO:
case SMG$K_TRM_ONE:
case SMG$K_TRM_TWO:
case SMG$K_TRM_THREE:
case SMG$K_TRM_FOUR:
case SMG$K_TRM_FIVE:
case SMG$K_TRM_SIX:
case SMG$K_TRM_SEVEN:
case SMG$K_TRM_EIGHT:
case SMG$K_TRM_NINE:
            if (!option)
            {
                ding(displayb);
                break;
            }
            /*
            **  a new fm_type and then the file manager
            */
            fm_type = key - SMG$K_TRM_ZERO;
            goto call_swing_files;

case SMG$K_TRM_EQUAL:
            if (!option)
            {
                ding(displayb);
                break;
            }
	    curr_l_ptr->n_ptr[current_level]->in_or_ex_clude = INCLUDE_FILES;
            if (get_new_dir_spec(curr_l_ptr->n_ptr[current_level]))
		goto call_swing_files;
	    else break;

case SMG$K_TRM_NUMBER_SIGN:
            if (!option)
            {
                ding(displayb);
                break;
            }
	    curr_l_ptr->n_ptr[current_level]->in_or_ex_clude = EXCLUDE_FILES;
            if (get_new_dir_spec(curr_l_ptr->n_ptr[current_level]))
		goto call_swing_files;
	    else break;

case SMG$K_TRM_UPPERCASE_F:
case SMG$K_TRM_LOWERCASE_F:
            if (!option)
            {
                ding(displayb);
                break;
            }
#ifndef MATS_HACK
case SMG$K_TRM_CR:
	    if (!option)
	    {
		return(SMG$K_TRM_CR);
		break;
	    }
#endif
	call_swing_files:;
            swing_files(curr_l_ptr->n_ptr[current_level],
                        curr_l_ptr->n_ptr[current_level]->last_filename,
                        SHOW_FILES);
	    if (total_files == 0)
		strcpy(curr_l_ptr->n_ptr[current_level]->dir_spec,
                       DEFAULT_DIR_SPEC);
            break;

case SMG$K_TRM_CTRLF:
            if (!option)
            {
                ding(displayb);
                break;
            }
            swing_files(curr_l_ptr->n_ptr[current_level],
                        "",
                        SHOW_DIRS);
            break;

case SMG$K_TRM_UPPERCASE_H:
case SMG$K_TRM_LOWERCASE_H:
            if (!option)
            {
                ding(displayb);
                break;
            }
            swing_help("SWING");
            break;

case SMG$K_TRM_UPPERCASE_M:
case SMG$K_TRM_LOWERCASE_M:
            if (!option)
            {
                ding(displayb);
                break;
            }
            move_dir();
            break;

case SMG$K_TRM_UPPERCASE_R:
case SMG$K_TRM_LOWERCASE_R:
            if (!option)
            {
                ding(displayb);
                break;
            }
            rename_dir();
            break;

case SMG$K_TRM_UPPERCASE_S:
case SMG$K_TRM_LOWERCASE_S:
            if (!option)
            {
                ding(displayb);
                break;
            }

            if (fdp->forw_ptr)
            {
		/*
		**  multiple structures present
                */
                while(1)
                {
                    message("Rebuild this structure ? [Y=yes, A=rebuild all structures] [N] ");
                    switch(get_key(NO_AUTO))
                    {
    case SMG$K_TRM_LOWERCASE_A:
    case SMG$K_TRM_UPPERCASE_A:
                        {
                            DSTRUCTURE *tmp;
                            char my_def[SPEC_SIZE+1];
                     
                            tmp = fdp;
                            show_def(my_def);
                            while(tmp)
                            {
                                set_default(tmp->dir_name);
                                search_nodes(tmp->dir_name,
                                             tmp->name,
                                             tmp);
                                tmp = tmp->forw_ptr;
                            }
                            load_lines();
                            set_default(my_def);
                            set_init_position();
                            refresh_display();
                            message("");
                        }
                        goto rebuild_over;
                        break;

    case SMG$K_TRM_LOWERCASE_Y:
    case SMG$K_TRM_UPPERCASE_Y:
                        goto one_structure;
                        break;

    case SMG$K_TRM_ENTER:
    case SMG$K_TRM_CR:
    case SMG$K_TRM_LOWERCASE_N:
    case SMG$K_TRM_UPPERCASE_N:
                        message("");
                        goto rebuild_over;
                        break;

    default:
                        warning("Invalid input - try again");
                        break;
                    }
                }
            }
            else
            {
                char my_def[SPEC_SIZE+1];

                /*
                **  just one structure present
                */
                if (!confirm_user("Rebuild this directory structure Y/N [N] ?","Y"))
                    break;
one_structure:;    
                show_def(my_def);
                set_default(curr_l_ptr->dp->dir_name);
                search_nodes(curr_l_ptr->dp->dir_name,
                             curr_l_ptr->dp->name,
                             curr_l_ptr->dp);
                load_lines();
                set_default(my_def);
                set_init_position();
                refresh_display();
                message("");
            }

rebuild_over:;
            break;

case SMG$K_TRM_CTRLJ:
case SMG$K_TRM_UP:
	    go_up();
            break;

case SMG$K_TRM_CTRLH:
case SMG$K_TRM_LEFT:
	    go_left();
            break;

case SMG$K_TRM_CTRLK:
case SMG$K_TRM_DOWN:
	    go_down();
            break;

case SMG$K_TRM_CTRLL:
case SMG$K_TRM_RIGHT:
	    go_right();
            break;

case SMG$K_TRM_UPPERCASE_N :
case SMG$K_TRM_LOWERCASE_N :
case SMG$K_TRM_NEXT_SCREEN :
	    go_next();
            break;

case SMG$K_TRM_CTRLI :
  	    if (current_line == total_lines - 1)
	        direction = DN_UPWARDS;
	    if (current_line == 0)
	        direction = DN_DOWNWARDS;

	    if (direction == DN_DOWNWARDS)
	    {
                render(current_line,current_level,NORMAL_RENDITION);

                current_line += TAB_SIZE;

                if (current_line > (total_lines - 1))
                    current_line = total_lines - 1;

                /*
                **  if we're on a line separating structures go down one more
                */
                curr_l_ptr = current_line_ptr(current_line);
                if (!curr_l_ptr->dp)
                {
                    current_line++;
                }

                curr_l_ptr = current_line_ptr(current_line);

                for (current_level = 0; 
                     current_level < MAX_LEVEL; 
                     current_level++)
		{
                    if (curr_l_ptr->n_ptr[current_level])
                    {
                        redo_display(TRUE);
                        render(current_line,current_level,SPECIAL_RENDITION);
                        break;
		    }
                }
	    }
	    else
	    {
                render(current_line,current_level,NORMAL_RENDITION);

                current_line -= TAB_SIZE;

                if (current_line < 0)
                    current_line = 0;

                /*
                **  if we're on a line separating structures go up one more
                */
                curr_l_ptr = current_line_ptr(current_line);
                if (!curr_l_ptr->dp)
                {
                    current_line--;
                }

                /*
                **  find node to show as special (current)
                */
                curr_l_ptr = current_line_ptr(current_line);

                for (current_level = 0; 
                     current_level < MAX_LEVEL; 
                     current_level++)
		{
                    if (curr_l_ptr->n_ptr[current_level])
                    {
                        redo_display(TRUE);
                        render(current_line,current_level,SPECIAL_RENDITION);
                        break;
		    }
                }

	    }
	    break;

case SMG$K_TRM_UPPERCASE_B :
case SMG$K_TRM_LOWERCASE_B :
	    go_bottom();
            break;

case SMG$K_TRM_PREV_SCREEN :
case SMG$K_TRM_UPPERCASE_P :
case SMG$K_TRM_LOWERCASE_P :
	    go_prev();
            break;

case SMG$K_TRM_UPPERCASE_T :
case SMG$K_TRM_LOWERCASE_T :
	    go_top();
            break;

case SMG$K_TRM_UPPERCASE_Q:
case SMG$K_TRM_LOWERCASE_Q:
#ifdef Q_EXITS_TO_ORIGINAL_DIR
            if (!option)
            {
                return(FALSE);
            }
            set_default(start_dir);
	    exit(1);
#endif
case SMG$K_TRM_LOWERCASE_E:
case SMG$K_TRM_UPPERCASE_E:
case SMG$K_TRM_CTRLZ:
#ifdef MATS_HACK
case SMG$K_TRM_CR:
#endif
            if (!option)
            {
                return(FALSE);
            }
	    exit(1);

case SMG$K_TRM_DELETE:              /* added by Mats */
            if (!option)
                return(SMG$K_TRM_DELETE); 
                 
case SMG$K_TRM_GREATER_THAN:
            if (!option)
                return(SMG$K_TRM_GREATER_THAN);
                 
default:
            if (!option)
            {
                ding(displayb);
                break;
            }
            if (!function_key(key,""))
                ding(displayb);
            break;
        }
    }
}

static int timer_count;
static int ast_auto;

#define DELTA_AST_TIME	"0 00:00:01"
#define GET_KEY_REQIDT	1001

get_key_ast()
{
    DSTRUCTURE *tmp;

    timer_count++;

    if (ast_auto & ALLOW_CLOCK)
    {
        smg$cancel_input(&keyboard);
	return(TRUE);
    }

    if ((ast_auto & ALLOW_AUTO) && timer_count == AUTO_UPDATE_DELAY)
    {
        tmp = fdp;
        while(tmp)
        {
            if (tmp->to_be_saved)
            {
                smg$cancel_input(&keyboard);
                return(TRUE);
            }
            tmp = tmp->forw_ptr;             
        }
    }            

    if ((timer_count >= MIN_BROADCAST_TIME) && outstanding_broadcasts)
    {
        smg$cancel_input(&keyboard);
	return(TRUE);
    }
    else
    {
        set_timer();
	return(TRUE);
    }
}

set_timer()
{
    int status;
    unsigned short timadr[4];

    status = sys$bintim(DSC1(DELTA_AST_TIME),
                        &timadr[0]);
    if (status != SS$_NORMAL)
        panic(status,"sys$bintim","set timer");

    status = sys$setimr(0,
                        &timadr[0],
                        get_key_ast,
                        GET_KEY_REQIDT,
                        0);
    if (status != SS$_NORMAL)
        panic(status,"sys$setimr","set timer");
}

cancel_timer()
{
    int status;

    status = sys$cantim(GET_KEY_REQIDT,
                        0);
    if (status != SS$_NORMAL)
        panic(status,"sys$cantim","cancel timer");
}

get_key(auto_update)
int auto_update;
{
    /*
    **  solicit a keystroke from the user, checking every second
    **  to see whether we have received a broadcast
    */
    short key;
    int row, column, i, c, copy_ast_auto, copy_timer_count;
    int my_con_update;
    DSTRUCTURE *tmp;

    row    = CUR_REST_Y;
    column = CUR_REST_X;
    ast_auto = auto_update;
    timer_count = 0;
    my_con_update = continual_update;
    continual_update = FALSE;
    set_timer();

    while(1)
    {
        key = 0;
        smg$set_cursor_abs(&displayb, &row, &column);
        i = smg$read_keystroke(&keyboard, 
                               &key,
                               0,
                               0,
                               0,
                               0);

        /*
        **  may have been cancelled if there are outstanding braodcasts
        **  or structures to save or its clock time
        */
        if (i == SS$_CANCEL || key == SMG$K_TRM_CANCELLED)
        {
            copy_ast_auto = ast_auto;
            copy_timer_count = timer_count;

            if (ast_auto & ALLOW_CLOCK)
            {
                update_clock();
            }

            if (outstanding_broadcasts)
            {
                show_broadcasts();
            }

            if ((ast_auto & ALLOW_AUTO) && timer_count == AUTO_UPDATE_DELAY)
            {
                tmp = fdp;
                while(tmp)
                {
                    if (tmp->to_be_saved)
                        save_nodes(tmp,FALSE);
                    tmp = tmp->forw_ptr;             
                }
            }            

            ast_auto = copy_ast_auto;
            timer_count = copy_timer_count;
	    if (my_con_update && 
                timer_count >= AUTO_CONTINUAL_UPDATE)
	    {
		return(SMG$K_TRM_CARET);
	    }

            set_timer();
            continue;
        }

        /*
        **  refresh
        */
        if (key == SMG$K_TRM_CTRLW ||
            key == SMG$K_TRM_CTRLR)
        {
            smg$repaint_screen(&paste);
            continue;
        }

	/*
	**  snapshot
	*/
	if (key == SMG$K_TRM_ASTERISK)
	{
	    snapshot();
 	    continue;
	}

        cancel_timer(); 

        /*
        **  if there was a message on the bottom line clear it
        */ 
        if (message_set)
            message("");

        if (i == SMG$_EOF)
        {
            return(SMG$K_TRM_CTRLZ);
        }

        return(key);
    }
}

/*
**  up-arrow
*/
go_up()
{
	    direction = DN_UPWARDS;
            /*
            **  up
            */
            if (current_line)
            {
                LINE *temp;
                int orig_line_no;

                temp = curr_l_ptr;
                orig_line_no = current_line;

                render(current_line,current_level,NORMAL_RENDITION);
                while(curr_l_ptr->back_ptr)
                {
                    current_line--;
                    curr_l_ptr = curr_l_ptr->back_ptr;
                    if (curr_l_ptr->n_ptr[current_level])
                    {
                        goto up_over;
                    }
                }
                current_line = orig_line_no;
                curr_l_ptr = temp;
             
  up_over:;
                redo_display(TRUE);
                render(current_line,current_level,SPECIAL_RENDITION);
            }
}

/*
**  down-arrow
*/
go_down()
{
	    direction = DN_DOWNWARDS;
            /*
            **  down
            */
            if (curr_l_ptr->forw_ptr)
            {
                LINE *temp;
                int orig_line_no;

                temp = curr_l_ptr;
                orig_line_no = current_line;

                render(current_line,current_level,NORMAL_RENDITION);
                while(curr_l_ptr->forw_ptr)
                {
                    current_line++;
                    curr_l_ptr = curr_l_ptr->forw_ptr;
                    if (curr_l_ptr->n_ptr[current_level])
                    {
                        goto down_over;
                    }
                }
                current_line = orig_line_no;
                curr_l_ptr = temp;
  down_over:;
                redo_display(TRUE);
                render(current_line,current_level,SPECIAL_RENDITION);
            }
}

/*
**  left-arrow
*/
go_left()
{
	    direction = DN_UPWARDS;
            if (current_level)
            {
                /*
                **  we can do it
                */
                render(current_line,current_level,NORMAL_RENDITION);
                current_level--;
                while(!curr_l_ptr->n_ptr[current_level])
                {
                    /*
                    **  go back a line
                    */
                    curr_l_ptr = curr_l_ptr->back_ptr;
                    current_line--;
                }
                redo_display(TRUE);
                render(current_line,current_level,SPECIAL_RENDITION);
            }
            else if (current_line)
            {
                /*
                **  now look for the previous node
                */
                render(current_line,current_level,NORMAL_RENDITION);

                /*
                **  up one line and start at the end
                */
                current_level = MAX_LEVEL - 1;
                current_line--;
                curr_l_ptr = curr_l_ptr->back_ptr;

                /*
                **  move left and upwards until we find a node
                */
                for ( ; ; current_line--)
                {
                    for ( ; current_level >= 0; current_level--)
                    {
                        if (curr_l_ptr->n_ptr[current_level])
                        {
                            redo_display(TRUE);
                            goto gone_left;
                        }
                    }
                    current_level = MAX_LEVEL - 1;
                    curr_l_ptr = curr_l_ptr->back_ptr;
                }

            gone_left:;
                render(current_line,current_level,SPECIAL_RENDITION);
            }
            else
                ding(displayb);
}

/*
**  right-arrow
*/
go_right()
{
	    direction = DN_DOWNWARDS;
            if (curr_l_ptr->forw_ptr || curr_l_ptr->n_ptr[current_level+1])
            {
                /*
                **  now look for the previous node
                */
                render(current_line,current_level,NORMAL_RENDITION);

                /*
                **  move one space to the right
                */
                if (current_level < (MAX_LEVEL - 1))
                {
                    /*
                    **  go to the right one
                    */
                    current_level++;
                }
                else
                {
                    /*
                    **  down one line and start at the beginning
                    */
                    current_level = 0;
                    current_line++;
                    curr_l_ptr = curr_l_ptr->forw_ptr;
                }

                /*
                **  move right and downwards until we find a node
                */
                for ( ; ; current_line++)
                {
                    for ( ; current_level < MAX_LEVEL; current_level++)
                    {
                        if (curr_l_ptr->n_ptr[current_level])
                        {
                            redo_display(TRUE);
                            goto gone_right;
                        }
                    }
                    current_level = 0;
                    curr_l_ptr = curr_l_ptr->forw_ptr;
                }

            gone_right:;
                render(current_line,current_level,SPECIAL_RENDITION);
            }
            else
                ding(displayb);
}

/*
**  top
*/
go_top()
{
	    direction = DN_DOWNWARDS;
            if (curr_l_ptr->back_ptr)
            {
                render(current_line,current_level,NORMAL_RENDITION);
                /*
                **  if there is another line drop down a line
                */
                curr_l_ptr = curr_l_ptr->back_ptr;
                current_line--;
  
                /*
                **  go up until next line dp is 0 or forw_ptr = 0
                */
                while(curr_l_ptr->back_ptr && curr_l_ptr->back_ptr->dp)
                {
                    curr_l_ptr = curr_l_ptr->back_ptr;
                    current_line--;
                }

                current_level = 0;
                redo_display(TRUE);

                render(current_line,current_level,SPECIAL_RENDITION);
            }
}

/*
**  bottom
*/
go_bottom()
{
	    direction = DN_UPWARDS;
            render(current_line,current_level,NORMAL_RENDITION);
            if (curr_l_ptr->forw_ptr)
            {
                /*
                **  if there is another line drop down a line
                */
                curr_l_ptr = curr_l_ptr->forw_ptr;
                current_line++;

                /*
                **  drop down until next line dp is 0 or forw_ptr = 0
                */
                while(curr_l_ptr->forw_ptr && curr_l_ptr->forw_ptr->dp)
                {
                    curr_l_ptr = curr_l_ptr->forw_ptr;
                    current_line++;
                }
            }

            for (current_level = MAX_LEVEL - 1; 
                 current_level >= 0; 
                 current_level--)
            {
                if (curr_l_ptr->n_ptr[current_level])
                {
                    redo_display(TRUE);
                    break;
                }
            }

            render(current_line,current_level,SPECIAL_RENDITION);
}

/*
**  next screen
*/
go_next()
{
	    direction = DN_DOWNWARDS;
            render(current_line,current_level,NORMAL_RENDITION);

            /*
            **  what we want to do is to advance forwards so that
            **  after screen has been refreshed
            **
            **  1) cursor at top of screen
            */
             
            current_line += PAGE_SIZE - 3;

            if (current_line > (total_lines - 1))
                current_line = total_lines - 1;

            /*
            **  if we're on a line separating structures go down one more
            */
            curr_l_ptr = current_line_ptr(current_line);
            if (!curr_l_ptr->dp)
            {
                current_line++;
            }

            /*
            **  now work out current top line
            */
            if ((current_line - (DISPLAY1_ROWS - 1)) > current_top_line)
                current_top_line = current_line - DISPLAY1_ROWS + 3;

	    /*
	    **  if we have moved current top line down too far
	    **  push it back up a bit
            */
            if ((total_lines - DISPLAY1_ROWS) < current_top_line)
                current_top_line = total_lines - DISPLAY1_ROWS;

	    /*
	    **  make sure it's not negative
	    */
            if (current_top_line < 0)
	        current_top_line = 0;

            /*
            **  find node to show as special (current)
            */
            curr_l_ptr = current_line_ptr(current_line);

            for (current_level = 0; current_level < MAX_LEVEL; current_level++)
                if (curr_l_ptr->n_ptr[current_level])
                {
                    refresh_display();
                    break;
                }
}

/*
**  previous screen
*/
go_prev()
{
	    direction = DN_UPWARDS;
            render(current_line,current_level,NORMAL_RENDITION);

            /*
            **  what we want to do is to retreat so that
            **  after screen has been refreshed
            **
            **  1) cursor is on top row
            */

            current_line -= PAGE_SIZE - 3;

            if (current_line < 0)
                current_line = 0;

            if (current_line < current_top_line)
                current_top_line = current_line - 2;

	    if (current_top_line < 0)
		current_top_line = 0;

            /*
            **  if we're on a line separating structures go up one more
            */
            curr_l_ptr = current_line_ptr(current_line);
            if (!curr_l_ptr->dp)
            {
                current_top_line--;
                current_line--;
            }

            /*
            **  find node to show as special (current)
            */
            curr_l_ptr = current_line_ptr(current_line);

            for (current_level = 0; current_level < MAX_LEVEL; current_level++)
                if (curr_l_ptr->n_ptr[current_level])
                {
                    refresh_display();
                    break;
                }
}
