/**************************************************************
**
**         C SWING  v 3.1   31-JUL-1989 09:08:42.59
**         =========================================
**
**         Author    :  S.J.Brown
**
**         Copyright :  Public Domain
**
**         File      :  SWING_23.C
**
**         Language  :  VAXC
**
**         Compiler  :  VAX/VMS C v 2.4
**
**         VMS Ver.  :  5.1
**
***************************************************************
**
**         Change History
**         ==============
**
**         Date        Change                          Initials
**         ----------------------------------------------------
**         31-JUL-1989 Initial Version v3.0               SJB
**
**************************************************************/
 
/*
**  swing_23.c - list display to printer
*/
#include <stdio.h>
#include <ssdef.h>
#include "more_descrip.h"
#include "swing.h"
#include "swing_refs.h"

/*
**  option == TRUE ==> use wide version
*/
create_listing(option,stats)
int option;
int stats;
{
    int i,count,j,timlen,stats_flag;
    int name_size;
    char line[133],name[NAME_LONG_SIZE+1],timbuf[40];
    char filename[SPEC_SIZE+1];
    char *p;
    float f;
    LINE *l;
    NODE *n;
    FILE *fp;
    DSTRUCTURE *d;

    if (option)
        name_size = NAME_LONG_SIZE;
    else
        name_size = NAME_SHORT_SIZE;

    fp = NULL;
    sprintf(filename,"SWING$SAVE:%s_XXXXXX.LIS",LISTING_FILE);
    p = mktemp(filename);
    if (p)
        fp = fopen(p,"w","fop=cbt","alq=8","mbc=8");
    if (fp == NULL)
    {
        sprintf(filename,"SYS$LOGIN:%s_XXXXXX.LIS",LISTING_FILE);
        p = mktemp(filename);
        if (p)
            fp = fopen(p,"w","fop=cbt","alq=8","mbc=8");
        if (fp == NULL)
        {
            sprintf(junk,"Cannot create file %s",filename);
            warning(junk);
	    return(TRUE);
        }
    }

    if (option)
        message("Creating wide listing ...");
    else
        message("Creating narrow listing ...");
    timlen = 0;
    sys$asctim(&timlen,DSCA1(timbuf),0,0);
    timbuf[timlen] = 0;
    fprintf(fp,"Directory Structure generated by %s\n",this_user);
    fprintf(fp,"\n");
    fprintf(fp,"Date of listing %s\n",timbuf);
    fprintf(fp,"\n");
    
    /*
    **  tell user what the stats info is
    */
    if (stats)
    {
	fprintf(fp,"Statistics codes\n");
	fprintf(fp,"================\n");
	fprintf(fp,"A - blocks allocated to files in this directory\n");
	fprintf(fp,"C - count of files in this directory\n");
	fprintf(fp,"I - file fragmentation index, the average number of\n");
	fprintf(fp,"    fragments per file\n");
	fprintf(fp,"M - maximum file size in blocks\n");
	fprintf(fp,"U - blocks used by files in this directory\n");
	fprintf(fp,"\n");
    }

    d = 0;
    l = first_line_ptr;
    while(l)
    {
        if (l->dp && l->dp != d)
        {
            if (d)
            {
                fprintf(fp,"\n");
                fprintf(fp,"\n");
            }
            fprintf(fp,"Root directory : %s\n",l->dp->dir_name);
            fprintf(fp,"\n");
            if (!d)
                fprintf(fp,"\n");
            d = l->dp;
            count = 0;
        }

        if (count)
        {
            line[0] = 0;
            for (i = 0; i < MAX_LEVEL; i++)
            {
                sprintf(_STR(line),"%-*.*s",name_size,name_size,"");
                sprintf(_STR(line),"%s",interline_joins[l->connections[i]]);
            }
            strip_line(line);
            fprintf(fp,"%s\n",line);
        }

        line[0] = 0;
	stats_flag = FALSE;

	if (stats)
	{
            for (i = 0; i < MAX_LEVEL; i++)
	    {
	        if (l->n_ptr[i] &&
		    l->n_ptr[i]->stats_collected)
	        {
		    stats_flag = TRUE;
		    break;
		}
	    }
	}

        for (i = 0; i < MAX_LEVEL; i++)
        {
            if (l->n_ptr[i])
            {
                n = l->n_ptr[i];
                sprintf(name,"%-*.*s",name_size,name_size,n->name);
                if (strlen(n->name) > name_size)
                    name[name_size-1] = '*';

                if (l->connections[i])
                {
                    for (j = 0; j < name_size; j++)
                        if (name[j] == ' ')
                            name[j] = '-';
                }
                strcat(_STR(line),name);
            }
            else
                sprintf(_STR(line),"%-*.*s",name_size,name_size,"");

            sprintf(_STR(line),"%s",listing_joins[l->connections[i]]);
        }
        strip_line(line);
        fprintf(fp,"%s\n",line);

	/*
	**  now the stats info if there is any for any node on this
	**  line of nodes
        */
	if (stats_flag)
        {
	    /*
	    **  blocks allocated
	    */
	    line[0] = 0;
            for (i = 0; i < MAX_LEVEL; i++)
            {
		name[0] = 0;

                if (l->n_ptr[i])
                {
                    n = l->n_ptr[i];
                    sprintf(name,
			    "A %d",
			    n->stats_total_size_alloc);
                }

                sprintf(_STR(line),
			"%-*.*s",
			name_size,
			name_size,
			name);
                strcat(_STR(line),
		       listing_joins[l->connections[i]]);
            }
            strip_line(line);
            fprintf(fp,"%s\n",line);

	    /*
	    **  blocks used
	    */
	    line[0] = 0;
            for (i = 0; i < MAX_LEVEL; i++)
            {
		name[0] = 0;

                if (l->n_ptr[i])
                {
                    n = l->n_ptr[i];
                    sprintf(name,
			    "U %d",
			    n->stats_total_size_used);
                }

                sprintf(_STR(line),
			"%-*.*s",
			name_size,
			name_size,
			name);
                strcat(_STR(line),
		       listing_joins[l->connections[i]]);
            }
            strip_line(line);
            fprintf(fp,"%s\n",line);

	    /*
	    **  total_files
	    */
	    line[0] = 0;
            for (i = 0; i < MAX_LEVEL; i++)
            {
		name[0] = 0;

                if (l->n_ptr[i])
                {
                    n = l->n_ptr[i];
                    sprintf(name,
			    "C %d",
			    n->stats_total_files);
                }

                sprintf(_STR(line),
			"%-*.*s",
			name_size,
			name_size,
			name);
                strcat(_STR(line),
		       listing_joins[l->connections[i]]);
            }
            strip_line(line);
            fprintf(fp,"%s\n",line);

	    /*
	    **  biggest file
	    */
	    line[0] = 0;
            for (i = 0; i < MAX_LEVEL; i++)
            {
		name[0] = 0;

                if (l->n_ptr[i])
                {
                    n = l->n_ptr[i];
                    sprintf(name,
			    "M %d",
			    n->stats_biggest_file);
                }

                sprintf(_STR(line),
			"%-*.*s",
			name_size,
			name_size,
			name);
                strcat(_STR(line),
		       listing_joins[l->connections[i]]);
            }
            strip_line(line);
            fprintf(fp,"%s\n",line);

	    /*
	    **  fragmentation
	    */
	    line[0] = 0;
            for (i = 0; i < MAX_LEVEL; i++)
            {
		name[0] = 0;

                if (l->n_ptr[i])
                {
		    f = n->stats_total_pointers;
		    if (n->stats_total_files)
			f = f / n->stats_total_files;
		    else
			f = 1;

                    n = l->n_ptr[i];
                    sprintf(name,
			    "I %.2f",
			    f);
                }

                sprintf(_STR(line),
			"%-*.*s",
			name_size,
			name_size,
			name);
                strcat(_STR(line),
		       listing_joins[l->connections[i]]);
            }
            strip_line(line);
            fprintf(fp,"%s\n",line);

	}

        l = l->forw_ptr;
        count++;
    }

    fgetname(fp,filename);

    fclose(fp);

    sprintf(junk,"Structure written to %s",filename);
    warning(junk);
}

/*
**  remove trailing spaces from a line
*/
strip_line(text)
char *text;
{
    int i, l;

    l = strlen(text);

    for (i = l - 1; i >= 0; i--)
    {
        if (text[i] != ' ')
        {
            text[i+1] = 0;
            return(TRUE);
         }
    }

    text[0] = 0;
    return(TRUE);
}
